/******************************************************************************
 * File Name   : MX_Device.h
 * Date        : 01/06/2023 13:50:32
 * Description : STM32Cube MX parameter definitions
 * Note        : This file is generated by STM32CubeMX (DO NOT EDIT!)
 ******************************************************************************/

#ifndef __MX_DEVICE_H
#define __MX_DEVICE_H

/*---------------------------- Clock Configuration ---------------------------*/

#define MX_LSI_VALUE                                32000
#define MX_LSIDIV_VALUE                             32000
#define MX_LSE_VALUE                                32768
#define MX_HSI_VALUE                                16000000
#define MX_HSICalibrationValue                      16
#define MX_HSE_VALUE                                16000000
#define MX_SYSCLKFreq_VALUE                         160000000
#define MX_HCLKFreq_Value                           160000000
#define MX_FCLKCortexFreq_Value                     160000000
#define MX_CortexFreq_Value                         160000000
#define MX_AHBFreq_Value                            160000000
#define MX_APB1Freq_Value                           160000000
#define MX_APB2Freq_Value                           160000000
#define MX_APB1TimFreq_Value                        160000000
#define MX_APB2TimFreq_Value                        160000000
#define MX_ADCFreq_Value                            16000000
#define MX_I2C1Freq_Value                           160000000
#define MX_I2C2Freq_Value                           160000000
#define MX_I2C3Freq_Value                           160000000
#define MX_MSI_VALUE                                4000000
#define MX_SPI1Freq_Value                           160000000
#define MX_SPI2Freq_Value                           160000000
#define MX_SPI3Freq_Value                           160000000
#define MX_USBFreq_Value                            48000000
#define MX_WatchDogFreq_Value                       32000
#define MX_LPTIM1Freq_Value                         4000000
#define MX_LPTIM2Freq_Value                         160000000
#define MX_RTCFreq_Value                            32000
#define MX_MCO1PinFreq_Value                        160000000
#define MX_CRSFreq_Value                            48000000
#define MX_SWPMI1Freq_Value                         4000000
#define MX_SAI1Freq_Value                           258000000
#define MX_SAI2Freq_Value                           258000000
#define MX_LPUART1Freq_Value                        160000000
#define MX_UART4Freq_Value                          160000000
#define MX_UART5Freq_Value                          160000000
#define MX_USART1Freq_Value                         160000000
#define MX_USART2Freq_Value                         160000000
#define MX_USART3Freq_Value                         160000000

/*-------------------------------- ADC4       --------------------------------*/

#define MX_ADC4                                     1

/*-------------------------------- ADF1       --------------------------------*/

#define MX_ADF1                                     1

/* GPIO Configuration */

/* Pin PE10 */
#define MX_ADF1_SDI0_GPIO_Speed                     GPIO_SPEED_FREQ_LOW
#define MX_ADF1_SDI0_Pin                            PE10
#define MX_ADF1_SDI0_GPIOx                          GPIOE
#define MX_ADF1_SDI0_GPIO_PuPd                      GPIO_NOPULL
#define MX_ADF1_SDI0_GPIO_Pin                       GPIO_PIN_10
#define MX_ADF1_SDI0_GPIO_AF                        GPIO_AF3_ADF1
#define MX_ADF1_SDI0_GPIO_Mode                      GPIO_MODE_AF_PP

/* Pin PE9 */
#define MX_ADF1_CCK0_GPIO_Speed                     GPIO_SPEED_FREQ_LOW
#define MX_ADF1_CCK0_Pin                            PE9
#define MX_ADF1_CCK0_GPIOx                          GPIOE
#define MX_ADF1_CCK0_GPIO_PuPd                      GPIO_NOPULL
#define MX_ADF1_CCK0_GPIO_Pin                       GPIO_PIN_9
#define MX_ADF1_CCK0_GPIO_AF                        GPIO_AF3_ADF1
#define MX_ADF1_CCK0_GPIO_Mode                      GPIO_MODE_AF_PP

/*-------------------------------- CORTEX_M33_NS --------------------------------*/

#define MX_CORTEX_M33_NS                            1

/*-------------------------------- GPDMA1     --------------------------------*/

#define MX_GPDMA1                                   1

#define MX_SPI2_TX_DMA_Instance                     1
#define MX_SPI2_RX_DMA_Instance                     1
#define MX_SPI1_TX_DMA_Instance                     1
#define MX_SPI1_RX_DMA_Instance                     1

/* NVIC Configuration */

/* NVIC GPDMA1_Channel2_IRQn */
#define MX_GPDMA1_Channel2_IRQn_interruptPremptionPriority 8
#define MX_GPDMA1_Channel2_IRQn_PriorityGroup       NVIC_PRIORITYGROUP_4
#define MX_GPDMA1_Channel2_IRQn_Subriority          0

/* NVIC GPDMA1_Channel4_IRQn */
#define MX_GPDMA1_Channel4_IRQn_interruptPremptionPriority 8
#define MX_GPDMA1_Channel4_IRQn_PriorityGroup       NVIC_PRIORITYGROUP_4
#define MX_GPDMA1_Channel4_IRQn_Subriority          0

/* NVIC GPDMA1_Channel3_IRQn */
#define MX_GPDMA1_Channel3_IRQn_interruptPremptionPriority 8
#define MX_GPDMA1_Channel3_IRQn_PriorityGroup       NVIC_PRIORITYGROUP_4
#define MX_GPDMA1_Channel3_IRQn_Subriority          0

/* NVIC GPDMA1_Channel5_IRQn */
#define MX_GPDMA1_Channel5_IRQn_interruptPremptionPriority 8
#define MX_GPDMA1_Channel5_IRQn_PriorityGroup       NVIC_PRIORITYGROUP_4
#define MX_GPDMA1_Channel5_IRQn_Subriority          0

/*-------------------------------- I2C1       --------------------------------*/

#define MX_I2C1                                     1

/* GPIO Configuration */

/* Pin PB8 */
#define MX_I2C1_SCL_GPIO_Speed                      GPIO_SPEED_FREQ_LOW
#define MX_I2C1_SCL_Pin                             PB8
#define MX_I2C1_SCL_GPIOx                           GPIOB
#define MX_I2C1_SCL_GPIO_Pin                        GPIO_PIN_8
#define MX_I2C1_SCL_GPIO_FM8                        __NULL
#define MX_I2C1_SCL_GPIO_AF                         GPIO_AF4_I2C1
#define MX_I2C1_SCL_GPIO_Pu                         GPIO_NOPULL
#define MX_I2C1_SCL_GPIO_Mode                       GPIO_MODE_AF_OD

/* Pin PB9 */
#define MX_I2C1_SDA_GPIO_Speed                      GPIO_SPEED_FREQ_LOW
#define MX_I2C1_SDA_Pin                             PB9
#define MX_I2C1_SDA_GPIOx                           GPIOB
#define MX_I2C1_SDA_GPIO_Pin                        GPIO_PIN_9
#define MX_I2C1_SDA_GPIO_AF                         GPIO_AF4_I2C1
#define MX_I2C1_SDA_GPIO_Pu                         GPIO_NOPULL
#define MX_I2C1_SDA_GPIO_Mode                       GPIO_MODE_AF_OD
#define MX_I2C1_SDA_GPIO_FM9                        __NULL

/*-------------------------------- I2C2       --------------------------------*/

#define MX_I2C2                                     1

/* GPIO Configuration */

/* Pin PH5 */
#define MX_I2C2_SDA_GPIO_Speed                      GPIO_SPEED_FREQ_LOW
#define MX_I2C2_SDA_Pin                             PH5
#define MX_I2C2_SDA_GPIOx                           GPIOH
#define MX_I2C2_SDA_GPIO_Pin                        GPIO_PIN_5
#define MX_I2C2_SDA_GPIO_AF                         GPIO_AF4_I2C2
#define MX_I2C2_SDA_GPIO_Pu                         GPIO_NOPULL
#define MX_I2C2_SDA_GPIO_Mode                       GPIO_MODE_AF_OD

/* Pin PH4 */
#define MX_I2C2_SCL_GPIO_Speed                      GPIO_SPEED_FREQ_LOW
#define MX_I2C2_SCL_Pin                             PH4
#define MX_I2C2_SCL_GPIOx                           GPIOH
#define MX_I2C2_SCL_GPIO_Pin                        GPIO_PIN_4
#define MX_I2C2_SCL_GPIO_AF                         GPIO_AF4_I2C2
#define MX_I2C2_SCL_GPIO_Pu                         GPIO_NOPULL
#define MX_I2C2_SCL_GPIO_Mode                       GPIO_MODE_AF_OD

/*-------------------------------- ICACHE     --------------------------------*/

#define MX_ICACHE                                   1

/*-------------------------------- OCTOSPI1   --------------------------------*/

#define MX_OCTOSPI1                                 1

/* GPIO Configuration */

/* Pin PF8 */
#define MX_OCTOSPIM_P1_IO0_Pin                      PF8
#define MX_OCTOSPIM_P1_IO0_GPIOx                    GPIOF
#define MX_OCTOSPIM_P1_IO0_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO0_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO0_GPIO_Pin                 GPIO_PIN_8
#define MX_OCTOSPIM_P1_IO0_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_IO0_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PH2 */
#define MX_OCTOSPIM_P1_IO4_Pin                      PH2
#define MX_OCTOSPIM_P1_IO4_GPIOx                    GPIOH
#define MX_OCTOSPIM_P1_IO4_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO4_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO4_GPIO_Pin                 GPIO_PIN_2
#define MX_OCTOSPIM_P1_IO4_GPIO_AF                  GPIO_AF3_OCTOSPI1
#define MX_OCTOSPIM_P1_IO4_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PB11 */
#define MX_OCTOSPIM_P1_NCS_Pin                      PB11
#define MX_OCTOSPIM_P1_NCS_GPIOx                    GPIOB
#define MX_OCTOSPIM_P1_NCS_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_NCS_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_NCS_GPIO_Pin                 GPIO_PIN_11
#define MX_OCTOSPIM_P1_NCS_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_NCS_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF6 */
#define MX_OCTOSPIM_P1_IO3_Pin                      PF6
#define MX_OCTOSPIM_P1_IO3_GPIOx                    GPIOF
#define MX_OCTOSPIM_P1_IO3_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO3_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO3_GPIO_Pin                 GPIO_PIN_6
#define MX_OCTOSPIM_P1_IO3_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_IO3_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF7 */
#define MX_OCTOSPIM_P1_IO2_Pin                      PF7
#define MX_OCTOSPIM_P1_IO2_GPIOx                    GPIOF
#define MX_OCTOSPIM_P1_IO2_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO2_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO2_GPIO_Pin                 GPIO_PIN_7
#define MX_OCTOSPIM_P1_IO2_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_IO2_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF9 */
#define MX_OCTOSPIM_P1_IO1_Pin                      PF9
#define MX_OCTOSPIM_P1_IO1_GPIOx                    GPIOF
#define MX_OCTOSPIM_P1_IO1_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO1_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO1_GPIO_Pin                 GPIO_PIN_9
#define MX_OCTOSPIM_P1_IO1_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_IO1_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PB10 */
#define MX_OCTOSPIM_P1_CLK_Pin                      PB10
#define MX_OCTOSPIM_P1_CLK_GPIOx                    GPIOB
#define MX_OCTOSPIM_P1_CLK_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_CLK_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_CLK_GPIO_Pin                 GPIO_PIN_10
#define MX_OCTOSPIM_P1_CLK_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_CLK_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PD7 */
#define MX_OCTOSPIM_P1_IO7_Pin                      PD7
#define MX_OCTOSPIM_P1_IO7_GPIOx                    GPIOD
#define MX_OCTOSPIM_P1_IO7_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO7_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO7_GPIO_Pin                 GPIO_PIN_7
#define MX_OCTOSPIM_P1_IO7_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_IO7_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PC3 */
#define MX_OCTOSPIM_P1_IO6_Pin                      PC3
#define MX_OCTOSPIM_P1_IO6_GPIOx                    GPIOC
#define MX_OCTOSPIM_P1_IO6_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO6_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO6_GPIO_Pin                 GPIO_PIN_3
#define MX_OCTOSPIM_P1_IO6_GPIO_AF                  GPIO_AF10_OCTOSPI1
#define MX_OCTOSPIM_P1_IO6_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PI0 */
#define MX_OCTOSPIM_P1_IO5_Pin                      PI0
#define MX_OCTOSPIM_P1_IO5_GPIOx                    GPIOI
#define MX_OCTOSPIM_P1_IO5_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_IO5_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_IO5_GPIO_Pin                 GPIO_PIN_0
#define MX_OCTOSPIM_P1_IO5_GPIO_AF                  GPIO_AF3_OCTOSPI1
#define MX_OCTOSPIM_P1_IO5_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PE3 */
#define MX_OCTOSPIM_P1_DQS_Pin                      PE3
#define MX_OCTOSPIM_P1_DQS_GPIOx                    GPIOE
#define MX_OCTOSPIM_P1_DQS_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P1_DQS_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P1_DQS_GPIO_Pin                 GPIO_PIN_3
#define MX_OCTOSPIM_P1_DQS_GPIO_AF                  GPIO_AF3_OCTOSPI1
#define MX_OCTOSPIM_P1_DQS_GPIO_Mode                GPIO_MODE_AF_PP

/*-------------------------------- OCTOSPI2   --------------------------------*/

#define MX_OCTOSPI2                                 1

/* GPIO Configuration */

/* Pin PF12 */
#define MX_OCTOSPIM_P2_DQS_Pin                      PF12
#define MX_OCTOSPIM_P2_DQS_GPIOx                    GPIOF
#define MX_OCTOSPIM_P2_DQS_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_DQS_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_DQS_GPIO_Pin                 GPIO_PIN_12
#define MX_OCTOSPIM_P2_DQS_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_DQS_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF1 */
#define MX_OCTOSPIM_P2_IO1_Pin                      PF1
#define MX_OCTOSPIM_P2_IO1_GPIOx                    GPIOF
#define MX_OCTOSPIM_P2_IO1_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO1_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO1_GPIO_Pin                 GPIO_PIN_1
#define MX_OCTOSPIM_P2_IO1_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO1_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF0 */
#define MX_OCTOSPIM_P2_IO0_Pin                      PF0
#define MX_OCTOSPIM_P2_IO0_GPIOx                    GPIOF
#define MX_OCTOSPIM_P2_IO0_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO0_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO0_GPIO_Pin                 GPIO_PIN_0
#define MX_OCTOSPIM_P2_IO0_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO0_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF3 */
#define MX_OCTOSPIM_P2_IO3_Pin                      PF3
#define MX_OCTOSPIM_P2_IO3_GPIOx                    GPIOF
#define MX_OCTOSPIM_P2_IO3_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO3_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO3_GPIO_Pin                 GPIO_PIN_3
#define MX_OCTOSPIM_P2_IO3_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO3_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF2 */
#define MX_OCTOSPIM_P2_IO2_Pin                      PF2
#define MX_OCTOSPIM_P2_IO2_GPIOx                    GPIOF
#define MX_OCTOSPIM_P2_IO2_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO2_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO2_GPIO_Pin                 GPIO_PIN_2
#define MX_OCTOSPIM_P2_IO2_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO2_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PH10 */
#define MX_OCTOSPIM_P2_IO5_Pin                      PH10
#define MX_OCTOSPIM_P2_IO5_GPIOx                    GPIOH
#define MX_OCTOSPIM_P2_IO5_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO5_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO5_GPIO_Pin                 GPIO_PIN_10
#define MX_OCTOSPIM_P2_IO5_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO5_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PI5 */
#define MX_OCTOSPIM_P2_NCS_Pin                      PI5
#define MX_OCTOSPIM_P2_NCS_GPIOx                    GPIOI
#define MX_OCTOSPIM_P2_NCS_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_NCS_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_NCS_GPIO_Pin                 GPIO_PIN_5
#define MX_OCTOSPIM_P2_NCS_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_NCS_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PH9 */
#define MX_OCTOSPIM_P2_IO4_Pin                      PH9
#define MX_OCTOSPIM_P2_IO4_GPIOx                    GPIOH
#define MX_OCTOSPIM_P2_IO4_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO4_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO4_GPIO_Pin                 GPIO_PIN_9
#define MX_OCTOSPIM_P2_IO4_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO4_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PH12 */
#define MX_OCTOSPIM_P2_IO7_Pin                      PH12
#define MX_OCTOSPIM_P2_IO7_GPIOx                    GPIOH
#define MX_OCTOSPIM_P2_IO7_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO7_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO7_GPIO_Pin                 GPIO_PIN_12
#define MX_OCTOSPIM_P2_IO7_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO7_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PH11 */
#define MX_OCTOSPIM_P2_IO6_Pin                      PH11
#define MX_OCTOSPIM_P2_IO6_GPIOx                    GPIOH
#define MX_OCTOSPIM_P2_IO6_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_IO6_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_IO6_GPIO_Pin                 GPIO_PIN_11
#define MX_OCTOSPIM_P2_IO6_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_IO6_GPIO_Mode                GPIO_MODE_AF_PP

/* Pin PF4 */
#define MX_OCTOSPIM_P2_CLK_Pin                      PF4
#define MX_OCTOSPIM_P2_CLK_GPIOx                    GPIOF
#define MX_OCTOSPIM_P2_CLK_GPIO_PuPd                GPIO_NOPULL
#define MX_OCTOSPIM_P2_CLK_GPIO_Speed_High_Default  GPIO_SPEED_FREQ_VERY_HIGH
#define MX_OCTOSPIM_P2_CLK_GPIO_Pin                 GPIO_PIN_4
#define MX_OCTOSPIM_P2_CLK_GPIO_AF                  GPIO_AF5_OCTOSPI2
#define MX_OCTOSPIM_P2_CLK_GPIO_Mode                GPIO_MODE_AF_PP

/*-------------------------------- PWR        --------------------------------*/

#define MX_PWR                                      1

/*-------------------------------- RNG        --------------------------------*/

#define MX_RNG                                      1

/*-------------------------------- RTC        --------------------------------*/

#define MX_RTC                                      1

/*-------------------------------- SPI1       --------------------------------*/

#define MX_SPI1                                     1

/* GPIO Configuration */

/* Pin PE14 */
#define MX_SPI1_MISO_GPIO_Speed                     GPIO_SPEED_FREQ_HIGH
#define MX_SPI1_MISO_Pin                            PE14
#define MX_SPI1_MISO_GPIOx                          GPIOE
#define MX_SPI1_MISO_GPIO_PuPd                      GPIO_NOPULL
#define MX_SPI1_MISO_GPIO_Pin                       GPIO_PIN_14
#define MX_SPI1_MISO_GPIO_AF                        GPIO_AF5_SPI1
#define MX_SPI1_MISO_GPIO_Mode                      GPIO_MODE_AF_PP

/* Pin PE15 */
#define MX_SPI1_MOSI_GPIO_Speed                     GPIO_SPEED_FREQ_HIGH
#define MX_SPI1_MOSI_Pin                            PE15
#define MX_SPI1_MOSI_GPIOx                          GPIOE
#define MX_SPI1_MOSI_GPIO_PuPd                      GPIO_NOPULL
#define MX_SPI1_MOSI_GPIO_Pin                       GPIO_PIN_15
#define MX_SPI1_MOSI_GPIO_AF                        GPIO_AF5_SPI1
#define MX_SPI1_MOSI_GPIO_Mode                      GPIO_MODE_AF_PP

/* Pin PE13 */
#define MX_SPI1_SCK_GPIO_Speed                      GPIO_SPEED_FREQ_HIGH
#define MX_SPI1_SCK_Pin                             PE13
#define MX_SPI1_SCK_GPIOx                           GPIOE
#define MX_SPI1_SCK_GPIO_PuPd                       GPIO_NOPULL
#define MX_SPI1_SCK_GPIO_Pin                        GPIO_PIN_13
#define MX_SPI1_SCK_GPIO_AF                         GPIO_AF5_SPI1
#define MX_SPI1_SCK_GPIO_Mode                       GPIO_MODE_AF_PP

/* NVIC Configuration */

/* NVIC SPI1_IRQn */
#define MX_SPI1_IRQn_interruptPremptionPriority     8
#define MX_SPI1_IRQn_PriorityGroup                  NVIC_PRIORITYGROUP_4
#define MX_SPI1_IRQn_Subriority                     0

/*-------------------------------- SPI2       --------------------------------*/

#define MX_SPI2                                     1

/* GPIO Configuration */

/* Pin PD1 */
#define MX_SPI2_SCK_GPIO_Speed                      GPIO_SPEED_FREQ_HIGH
#define MX_SPI2_SCK_Pin                             PD1
#define MX_SPI2_SCK_GPIOx                           GPIOD
#define MX_SPI2_SCK_GPIO_PuPd                       GPIO_NOPULL
#define MX_SPI2_SCK_GPIO_Pin                        GPIO_PIN_1
#define MX_SPI2_SCK_GPIO_AF                         GPIO_AF5_SPI2
#define MX_SPI2_SCK_GPIO_Mode                       GPIO_MODE_AF_PP

/* Pin PD4 */
#define MX_SPI2_MOSI_GPIO_Speed                     GPIO_SPEED_FREQ_HIGH
#define MX_SPI2_MOSI_Pin                            PD4
#define MX_SPI2_MOSI_GPIOx                          GPIOD
#define MX_SPI2_MOSI_GPIO_PuPd                      GPIO_NOPULL
#define MX_SPI2_MOSI_GPIO_Pin                       GPIO_PIN_4
#define MX_SPI2_MOSI_GPIO_AF                        GPIO_AF5_SPI2
#define MX_SPI2_MOSI_GPIO_Mode                      GPIO_MODE_AF_PP

/* Pin PD3 */
#define MX_SPI2_MISO_GPIO_Speed                     GPIO_SPEED_FREQ_HIGH
#define MX_SPI2_MISO_Pin                            PD3
#define MX_SPI2_MISO_GPIOx                          GPIOD
#define MX_SPI2_MISO_GPIO_PuPd                      GPIO_NOPULL
#define MX_SPI2_MISO_GPIO_Pin                       GPIO_PIN_3
#define MX_SPI2_MISO_GPIO_AF                        GPIO_AF5_SPI2
#define MX_SPI2_MISO_GPIO_Mode                      GPIO_MODE_AF_PP

/* NVIC Configuration */

/* NVIC SPI2_IRQn */
#define MX_SPI2_IRQn_interruptPremptionPriority     8
#define MX_SPI2_IRQn_PriorityGroup                  NVIC_PRIORITYGROUP_4
#define MX_SPI2_IRQn_Subriority                     0

/*-------------------------------- SYS        --------------------------------*/

#define MX_SYS                                      1

/*-------------------------------- UART4      --------------------------------*/

#define MX_UART4                                    1

#define MX_UART4_VM                                 VM_ASYNC

/* GPIO Configuration */

/* Pin PC11 */
#define MX_UART4_RX_GPIO_ModeDefaultPP              GPIO_MODE_AF_PP
#define MX_UART4_RX_GPIO_Speed                      GPIO_SPEED_FREQ_LOW
#define MX_UART4_RX_Pin                             PC11
#define MX_UART4_RX_GPIOx                           GPIOC
#define MX_UART4_RX_GPIO_PuPd                       GPIO_NOPULL
#define MX_UART4_RX_GPIO_Pin                        GPIO_PIN_11
#define MX_UART4_RX_GPIO_AF                         GPIO_AF8_UART4

/* Pin PC10 */
#define MX_UART4_TX_GPIO_ModeDefaultPP              GPIO_MODE_AF_PP
#define MX_UART4_TX_GPIO_Speed                      GPIO_SPEED_FREQ_LOW
#define MX_UART4_TX_Pin                             PC10
#define MX_UART4_TX_GPIOx                           GPIOC
#define MX_UART4_TX_GPIO_PuPd                       GPIO_NOPULL
#define MX_UART4_TX_GPIO_Pin                        GPIO_PIN_10
#define MX_UART4_TX_GPIO_AF                         GPIO_AF8_UART4

/* NVIC Configuration */

/* NVIC UART4_IRQn */
#define MX_UART4_IRQn_interruptPremptionPriority    8
#define MX_UART4_IRQn_PriorityGroup                 NVIC_PRIORITYGROUP_4
#define MX_UART4_IRQn_Subriority                    0

/*-------------------------------- USART1     --------------------------------*/

#define MX_USART1                                   1

#define MX_USART1_VM                                VM_ASYNC

/* GPIO Configuration */

/* Pin PA9 */
#define MX_USART1_TX_GPIO_ModeDefaultPP             GPIO_MODE_AF_PP
#define MX_USART1_TX_GPIO_Speed                     GPIO_SPEED_FREQ_LOW
#define MX_USART1_TX_Pin                            PA9
#define MX_USART1_TX_GPIOx                          GPIOA
#define MX_USART1_TX_GPIO_PuPd                      GPIO_NOPULL
#define MX_USART1_TX_GPIO_Pin                       GPIO_PIN_9
#define MX_USART1_TX_GPIO_AF                        GPIO_AF7_USART1

/* Pin PA10 */
#define MX_USART1_RX_GPIO_ModeDefaultPP             GPIO_MODE_AF_PP
#define MX_USART1_RX_GPIO_Speed                     GPIO_SPEED_FREQ_LOW
#define MX_USART1_RX_Pin                            PA10
#define MX_USART1_RX_GPIOx                          GPIOA
#define MX_USART1_RX_GPIO_PuPd                      GPIO_NOPULL
#define MX_USART1_RX_GPIO_Pin                       GPIO_PIN_10
#define MX_USART1_RX_GPIO_AF                        GPIO_AF7_USART1

/* NVIC Configuration */

/* NVIC USART1_IRQn */
#define MX_USART1_IRQn_interruptPremptionPriority   8
#define MX_USART1_IRQn_PriorityGroup                NVIC_PRIORITYGROUP_4
#define MX_USART1_IRQn_Subriority                   0

/*-------------------------------- USART3     --------------------------------*/

#define MX_USART3                                   1

#define MX_USART3_VM                                VM_ASYNC

/* GPIO Configuration */

/* Pin PD8 */
#define MX_USART3_TX_GPIO_ModeDefaultPP             GPIO_MODE_AF_PP
#define MX_USART3_TX_GPIO_Speed                     GPIO_SPEED_FREQ_MEDIUM
#define MX_USART3_TX_Pin                            PD8
#define MX_USART3_TX_GPIOx                          GPIOD
#define MX_USART3_TX_GPIO_PuPd                      GPIO_NOPULL
#define MX_USART3_TX_GPIO_Pin                       GPIO_PIN_8
#define MX_USART3_TX_GPIO_AF                        GPIO_AF7_USART3

/* Pin PD9 */
#define MX_USART3_RX_GPIO_ModeDefaultPP             GPIO_MODE_AF_PP
#define MX_USART3_RX_GPIO_Speed                     GPIO_SPEED_FREQ_MEDIUM
#define MX_USART3_RX_Pin                            PD9
#define MX_USART3_RX_GPIOx                          GPIOD
#define MX_USART3_RX_GPIO_PuPd                      GPIO_NOPULL
#define MX_USART3_RX_GPIO_Pin                       GPIO_PIN_9
#define MX_USART3_RX_GPIO_AF                        GPIO_AF7_USART3

/* NVIC Configuration */

/* NVIC USART3_IRQn */
#define MX_USART3_IRQn_interruptPremptionPriority   8
#define MX_USART3_IRQn_PriorityGroup                NVIC_PRIORITYGROUP_4
#define MX_USART3_IRQn_Subriority                   0

/*-------------------------------- UCPD1      --------------------------------*/

#define MX_UCPD1                                    1

/* GPIO Configuration */

/* Pin PB15 */
#define MX_UCPD1_CC2_Pin                            PB15
#define MX_UCPD1_CC2_GPIOx                          GPIOB
#define MX_UCPD1_CC2_GPIO_PuPd                      GPIO_NOPULL
#define MX_UCPD1_CC2_GPIO_Pin                       GPIO_PIN_15
#define MX_UCPD1_CC2_GPIO_Mode                      GPIO_MODE_ANALOG

/* Pin PA15 (JTDI) */
#define MX_UCPD1_CC1_Pin                            PA15_JTDI
#define MX_UCPD1_CC1_GPIOx                          GPIOA
#define MX_UCPD1_CC1_GPIO_PuPd                      GPIO_NOPULL
#define MX_UCPD1_CC1_GPIO_Pin                       GPIO_PIN_15
#define MX_UCPD1_CC1_GPIO_Mode                      GPIO_MODE_ANALOG

/*-------------------------------- USB_OTG_FS --------------------------------*/

#define MX_USB_OTG_FS                               1

#define MX_USB_OTG_FS_DEVICE                        1

/* GPIO Configuration */

/* Pin PA11 */
#define MX_USB_OTG_FS_DM_GPIO_Speed                 GPIO_SPEED_FREQ_HIGH
#define MX_USB_OTG_FS_DM_Pin                        PA11
#define MX_USB_OTG_FS_DM_GPIOx                      GPIOA
#define MX_USB_OTG_FS_DM_GPIO_PuPd                  GPIO_NOPULL
#define MX_USB_OTG_FS_DM_GPIO_Pin                   GPIO_PIN_11
#define MX_USB_OTG_FS_DM_GPIO_AF                    GPIO_AF10_USB
#define MX_USB_OTG_FS_DM_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PA12 */
#define MX_USB_OTG_FS_DP_GPIO_Speed                 GPIO_SPEED_FREQ_HIGH
#define MX_USB_OTG_FS_DP_Pin                        PA12
#define MX_USB_OTG_FS_DP_GPIOx                      GPIOA
#define MX_USB_OTG_FS_DP_GPIO_PuPd                  GPIO_NOPULL
#define MX_USB_OTG_FS_DP_GPIO_Pin                   GPIO_PIN_12
#define MX_USB_OTG_FS_DP_GPIO_AF                    GPIO_AF10_USB
#define MX_USB_OTG_FS_DP_GPIO_Mode                  GPIO_MODE_AF_PP

/*-------------------------------- NVIC       --------------------------------*/

#define MX_NVIC                                     1

/*-------------------------------- GPIO       --------------------------------*/

#define MX_GPIO                                     1

/* GPIO Configuration */

/* Pin PB5 - UCPD_PWR */
#define MX_PB5_GPIO_Speed                           GPIO_SPEED_FREQ_LOW
#define MX_PB5_Pin                                  PB5
#define MX_PB5_GPIOx                                GPIOB
#define MX_PB5_PinState                             GPIO_PIN_RESET
#define MX_PB5_GPIO_PuPd                            GPIO_NOPULL
#define MX_PB5_GPIO_Pin                             GPIO_PIN_5
#define MX_PB5_GPIO_ModeDefaultOutputPP             GPIO_MODE_OUTPUT_PP

#define MX_UCPD_PWR_GPIO_Speed                      MX_PB5_GPIO_Speed
#define MX_UCPD_PWR_Pin                             MX_PB5_Pin
#define MX_UCPD_PWR_GPIOx                           MX_PB5_GPIOx
#define MX_UCPD_PWR_PinState                        MX_PB5_PinState
#define MX_UCPD_PWR_GPIO_PuPd                       MX_PB5_GPIO_PuPd
#define MX_UCPD_PWR_GPIO_Pin                        MX_PB5_GPIO_Pin
#define MX_UCPD_PWR_GPIO_ModeDefaultOutputPP        MX_PB5_GPIO_ModeDefaultOutputPP

/* Pin PH3-BOOT0 */
#define MX_PH3_BOOT0_Pin                            PH3_BOOT0
#define MX_PH3_BOOT0_GPIOx                          GPIOH
#define MX_PH3_BOOT0_GPIO_PuPd                      GPIO_NOPULL
#define MX_PH3_BOOT0_GPIO_Pin                       GPIO_PIN_3
#define MX_PH3_BOOT0_GPIO_Mode                      GPIO_MODE_INPUT

/* Pin PH1-OSC_OUT (PH1) - Mems.VL53_xshut */
#define MX_PH1_OSC_OUT_PH1_GPIO_Speed               GPIO_SPEED_FREQ_LOW
#define MX_PH1_OSC_OUT_PH1_Pin                      PH1_OSC_OUT_PH1
#define MX_PH1_OSC_OUT_PH1_GPIOx                    GPIOH
#define MX_PH1_OSC_OUT_PH1_PinState                 GPIO_PIN_RESET
#define MX_PH1_OSC_OUT_PH1_GPIO_PuPd                GPIO_NOPULL
#define MX_PH1_OSC_OUT_PH1_GPIO_Pin                 GPIO_PIN_1
#define MX_PH1_OSC_OUT_PH1_GPIO_ModeDefaultOutputPP GPIO_MODE_OUTPUT_PP

#define MX_Mems_VL53_xshut_GPIO_Speed               MX_PH1_OSC_OUT_PH1_GPIO_Speed
#define MX_Mems_VL53_xshut_Pin                      MX_PH1_OSC_OUT_PH1_Pin
#define MX_Mems_VL53_xshut_GPIOx                    MX_PH1_OSC_OUT_PH1_GPIOx
#define MX_Mems_VL53_xshut_PinState                 MX_PH1_OSC_OUT_PH1_PinState
#define MX_Mems_VL53_xshut_GPIO_PuPd                MX_PH1_OSC_OUT_PH1_GPIO_PuPd
#define MX_Mems_VL53_xshut_GPIO_Pin                 MX_PH1_OSC_OUT_PH1_GPIO_Pin
#define MX_Mems_VL53_xshut_GPIO_ModeDefaultOutputPP MX_PH1_OSC_OUT_PH1_GPIO_ModeDefaultOutputPP

/* Pin PC13 - USER_Button */
#define MX_PC13_Pin                                 PC13
#define MX_PC13_GPIOx                               GPIOC
#define MX_PC13_GPIO_PuPd                           GPIO_NOPULL
#define MX_PC13_GPIO_Pin                            GPIO_PIN_13
#define MX_PC13_GPIO_Mode                           GPIO_MODE_INPUT

#define MX_USER_Button_Pin                          MX_PC13_Pin
#define MX_USER_Button_GPIOx                        MX_PC13_GPIOx
#define MX_USER_Button_GPIO_PuPd                    MX_PC13_GPIO_PuPd
#define MX_USER_Button_GPIO_Pin                     MX_PC13_GPIO_Pin
#define MX_USER_Button_GPIO_Mode                    MX_PC13_GPIO_Mode

/* Pin PE11 - Mems.ISM330DLC_INT1 */
#define MX_PE11_Pin                                 PE11
#define MX_PE11_GPIOx                               GPIOE
#define MX_PE11_GPIO_PuPd                           GPIO_NOPULL
#define MX_PE11_GPIO_Pin                            GPIO_PIN_11
#define MX_PE11_GPIO_Mode                           GPIO_MODE_INPUT

#define MX_Mems_ISM330DLC_INT1_Pin                  MX_PE11_Pin
#define MX_Mems_ISM330DLC_INT1_GPIOx                MX_PE11_GPIOx
#define MX_Mems_ISM330DLC_INT1_GPIO_PuPd            MX_PE11_GPIO_PuPd
#define MX_Mems_ISM330DLC_INT1_GPIO_Pin             MX_PE11_GPIO_Pin
#define MX_Mems_ISM330DLC_INT1_GPIO_Mode            MX_PE11_GPIO_Mode

/* Pin PD13 - USB.IANA */
#define MX_PD13_Pin                                 PD13
#define MX_PD13_GPIOx                               GPIOD
#define MX_PD13_GPIO_PuPd                           GPIO_NOPULL
#define MX_PD13_GPIO_Pin                            GPIO_PIN_13
#define MX_PD13_GPIO_Mode                           GPIO_MODE_INPUT

#define MX_USB_IANA_Pin                             MX_PD13_Pin
#define MX_USB_IANA_GPIOx                           MX_PD13_GPIOx
#define MX_USB_IANA_GPIO_PuPd                       MX_PD13_GPIO_PuPd
#define MX_USB_IANA_GPIO_Pin                        MX_PD13_GPIO_Pin
#define MX_USB_IANA_GPIO_Mode                       MX_PD13_GPIO_Mode

/* Pin PF11 - Mems.STSAFE_RESET */
#define MX_PF11_GPIO_Speed                          GPIO_SPEED_FREQ_LOW
#define MX_PF11_Pin                                 PF11
#define MX_PF11_GPIOx                               GPIOF
#define MX_PF11_PinState                            GPIO_PIN_RESET
#define MX_PF11_GPIO_PuPd                           GPIO_NOPULL
#define MX_PF11_GPIO_Pin                            GPIO_PIN_11
#define MX_PF11_GPIO_ModeDefaultOutputPP            GPIO_MODE_OUTPUT_PP

#define MX_Mems_STSAFE_RESET_GPIO_Speed             MX_PF11_GPIO_Speed
#define MX_Mems_STSAFE_RESET_Pin                    MX_PF11_Pin
#define MX_Mems_STSAFE_RESET_GPIOx                  MX_PF11_GPIOx
#define MX_Mems_STSAFE_RESET_PinState               MX_PF11_PinState
#define MX_Mems_STSAFE_RESET_GPIO_PuPd              MX_PF11_GPIO_PuPd
#define MX_Mems_STSAFE_RESET_GPIO_Pin               MX_PF11_GPIO_Pin
#define MX_Mems_STSAFE_RESET_GPIO_ModeDefaultOutputPP MX_PF11_GPIO_ModeDefaultOutputPP

/* Pin PD10 - Mems.INT_IIS2MDC */
#define MX_PD10_Pin                                 PD10
#define MX_PD10_GPIOx                               GPIOD
#define MX_PD10_GPIO_PuPd                           GPIO_NOPULL
#define MX_PD10_GPIO_Pin                            GPIO_PIN_10
#define MX_PD10_GPIO_Mode                           GPIO_MODE_INPUT

#define MX_Mems_INT_IIS2MDC_Pin                     MX_PD10_Pin
#define MX_Mems_INT_IIS2MDC_GPIOx                   MX_PD10_GPIOx
#define MX_Mems_INT_IIS2MDC_GPIO_PuPd               MX_PD10_GPIO_PuPd
#define MX_Mems_INT_IIS2MDC_GPIO_Pin                MX_PD10_GPIO_Pin
#define MX_Mems_INT_IIS2MDC_GPIO_Mode               MX_PD10_GPIO_Mode

/* Pin PG2 - Mems.INT_LPS22HH */
#define MX_PG2_Pin                                  PG2
#define MX_PG2_GPIOx                                GPIOG
#define MX_PG2_GPIO_PuPd                            GPIO_NOPULL
#define MX_PG2_GPIO_Pin                             GPIO_PIN_2
#define MX_PG2_GPIO_Mode                            GPIO_MODE_INPUT

#define MX_Mems_INT_LPS22HH_Pin                     MX_PG2_Pin
#define MX_Mems_INT_LPS22HH_GPIOx                   MX_PG2_GPIOx
#define MX_Mems_INT_LPS22HH_GPIO_PuPd               MX_PG2_GPIO_PuPd
#define MX_Mems_INT_LPS22HH_GPIO_Pin                MX_PG2_GPIO_Pin
#define MX_Mems_INT_LPS22HH_GPIO_Mode               MX_PG2_GPIO_Mode

/* Pin PF14 - USB.VBUS_SENSE */
#define MX_PF14_Pin                                 PF14
#define MX_PF14_GPIOx                               GPIOF
#define MX_PF14_GPIO_PuPd                           GPIO_NOPULL
#define MX_PF14_GPIO_Pin                            GPIO_PIN_14
#define MX_PF14_GPIO_Mode                           GPIO_MODE_ANALOG

#define MX_USB_VBUS_SENSE_Pin                       MX_PF14_Pin
#define MX_USB_VBUS_SENSE_GPIOx                     MX_PF14_GPIOx
#define MX_USB_VBUS_SENSE_GPIO_PuPd                 MX_PF14_GPIO_PuPd
#define MX_USB_VBUS_SENSE_GPIO_Pin                  MX_PF14_GPIO_Pin
#define MX_USB_VBUS_SENSE_GPIO_Mode                 MX_PF14_GPIO_Mode

/* Pin PH7 - LED_GREEN */
#define MX_PH7_GPIO_Speed                           GPIO_SPEED_FREQ_LOW
#define MX_PH7_Pin                                  PH7
#define MX_PH7_GPIOx                                GPIOH
#define MX_PH7_PinState                             GPIO_PIN_RESET
#define MX_PH7_GPIO_PuPd                            GPIO_NOPULL
#define MX_PH7_GPIO_Pin                             GPIO_PIN_7
#define MX_PH7_GPIO_ModeDefaultOutputPP             GPIO_MODE_OUTPUT_PP

#define MX_LED_GREEN_GPIO_Speed                     MX_PH7_GPIO_Speed
#define MX_LED_GREEN_Pin                            MX_PH7_Pin
#define MX_LED_GREEN_GPIOx                          MX_PH7_GPIOx
#define MX_LED_GREEN_PinState                       MX_PH7_PinState
#define MX_LED_GREEN_GPIO_PuPd                      MX_PH7_GPIO_PuPd
#define MX_LED_GREEN_GPIO_Pin                       MX_PH7_GPIO_Pin
#define MX_LED_GREEN_GPIO_ModeDefaultOutputPP       MX_PH7_GPIO_ModeDefaultOutputPP

/* Pin PG6 - WRLS.WKUP_B */
#define MX_PG6_GPIO_Speed                           GPIO_SPEED_FREQ_LOW
#define MX_PG6_Pin                                  PG6
#define MX_PG6_GPIOx                                GPIOG
#define MX_PG6_PinState                             GPIO_PIN_RESET
#define MX_PG6_GPIO_PuPd                            GPIO_NOPULL
#define MX_PG6_GPIO_Pin                             GPIO_PIN_6
#define MX_PG6_GPIO_ModeDefaultOutputPP             GPIO_MODE_OUTPUT_PP

#define MX_WRLS_WKUP_B_GPIO_Speed                   MX_PG6_GPIO_Speed
#define MX_WRLS_WKUP_B_Pin                          MX_PG6_Pin
#define MX_WRLS_WKUP_B_GPIOx                        MX_PG6_GPIOx
#define MX_WRLS_WKUP_B_PinState                     MX_PG6_PinState
#define MX_WRLS_WKUP_B_GPIO_PuPd                    MX_PG6_GPIO_PuPd
#define MX_WRLS_WKUP_B_GPIO_Pin                     MX_PG6_GPIO_Pin
#define MX_WRLS_WKUP_B_GPIO_ModeDefaultOutputPP     MX_PG6_GPIO_ModeDefaultOutputPP

/* Pin PH6 - LED_RED */
#define MX_PH6_GPIO_Speed                           GPIO_SPEED_FREQ_LOW
#define MX_PH6_Pin                                  PH6
#define MX_PH6_GPIOx                                GPIOH
#define MX_PH6_PinState                             GPIO_PIN_RESET
#define MX_PH6_GPIO_PuPd                            GPIO_NOPULL
#define MX_PH6_GPIO_Pin                             GPIO_PIN_6
#define MX_PH6_GPIO_ModeDefaultOutputPP             GPIO_MODE_OUTPUT_PP

#define MX_LED_RED_GPIO_Speed                       MX_PH6_GPIO_Speed
#define MX_LED_RED_Pin                              MX_PH6_Pin
#define MX_LED_RED_GPIOx                            MX_PH6_GPIOx
#define MX_LED_RED_PinState                         MX_PH6_PinState
#define MX_LED_RED_GPIO_PuPd                        MX_PH6_GPIO_PuPd
#define MX_LED_RED_GPIO_Pin                         MX_PH6_GPIO_Pin
#define MX_LED_RED_GPIO_ModeDefaultOutputPP         MX_PH6_GPIO_ModeDefaultOutputPP

/* Pin PG5 - Mems.VLX_GPIO */
#define MX_PG5_Pin                                  PG5
#define MX_PG5_GPIOx                                GPIOG
#define MX_PG5_GPIO_PuPd                            GPIO_NOPULL
#define MX_PG5_GPIO_Pin                             GPIO_PIN_5
#define MX_PG5_GPIO_Mode                            GPIO_MODE_INPUT

#define MX_Mems_VLX_GPIO_Pin                        MX_PG5_Pin
#define MX_Mems_VLX_GPIO_GPIOx                      MX_PG5_GPIOx
#define MX_Mems_VLX_GPIO_GPIO_PuPd                  MX_PG5_GPIO_PuPd
#define MX_Mems_VLX_GPIO_GPIO_Pin                   MX_PG5_GPIO_Pin
#define MX_Mems_VLX_GPIO_GPIO_Mode                  MX_PG5_GPIO_Mode

#endif  /* __MX_DEVICE_H */

