/* -----------------------------------------------------------------------------
 * Copyright (c) 2022 Arm Limited (or its affiliates). All rights reserved.
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the License); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *
 * $Date:        15. March 2022
 * $Revision:    V1.0
 *
 * Project:      WiFi Driver Configuration for MXCHIP EMW3080 WiFi Module
 * -------------------------------------------------------------------------- */

//-------- <<< Use Configuration Wizard in Context Menu >>> --------------------

#ifndef WIFI_EMW3080_CONFIG_H__
#define WIFI_EMW3080_CONFIG_H__

// <h> WiFi MXCHIP EMW3080 Driver Configuration

//   <o> WiFi Driver Number
//   <i> Configuration setting specifying driver number (default: Driver_WiFi0)
#define WIFI_EMW3080_DRV_NUM                0

// </h>

// Maximum scan buffer size (default: 2048)
#define WIFI_EMW3080_SCAN_BUF_SIZE         (2048)

// Number of sockets supported by Module (default: 4)
#define WIFI_EMW3080_SOCKETS_NUM           (4)

// Maximum socket transfer buffer (default: 1500)
#define WIFI_EMW3080_SOCKETS_RX_BUF_SIZE   (1500)

// Socket access lock timeout (default: 10000 ms)
#define WIFI_EMW3080_SOCKETS_TIMEOUT       (10000)

// Socket default receive timeout (default: 20000 ms)
#define WIFI_EMW3080_SOCKETS_RCVTIMEO      (20000)

// Interval in milliseconds for emulating blocking sockets (default: 250 ms)
#define WIFI_EMW3080_SOCKETS_INTERVAL      (250)

#endif // WIFI_EMW3080_CONFIG_H__
