/*
 * Copyright (c) 2023 Arm Limited. All rights reserved.
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the License); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Name:    sdsio_config_socket.h
 * Purpose: SDS IO via Socket (IoT Utility:Socket) configuration options
 * Rev.:    V1.0.0
 */

//-------- <<< Use Configuration Wizard in Context Menu >>> --------------------

// <h>SDS IO via Socket (IoT Utility:Socket)

//   <s.16>SDSIO-Server IP
//   <i>SDSIO socket server IPv4 address
//   <i>Default: "0.0.0.0"
#define SDSIO_SERVER_IP           "0.0.0.0"

//   <o>SDSIO-Server port
//   <i>SDSIO socket server port
//   <i>Default: 5050
#define SDSIO_SERVER_PORT         5050U

//   <o>Socket receive timeout
//   <i>Socket receive timeout in ms
//   <i>Default: 5000
#define SDSIO_SOCKET_RECEIVE_TOUT 5000U

// </h>

//------------- <<< end of configuration section >>> ---------------------------
